<?php

require_once 'base.batch.inc';

/**
 * Batch operation. Import dadaIMC media as nodes.
 *
 * Fields not imported:
 * | modified_by | deleted | filesize | mime_class | orig_filename | sequence_number | filename | height | width | duration |  parentid | artist | keywords | media_date | rating | remote | alignment | metafile |license | exif_data | contributor 

 */
class dadaImportMedia extends BaseBatchOperation implements iBatchOperation {
  public $token = 'media';

  function getTotal() {
    $query = "SELECT COUNT(*) FROM media WHERE parent_class=''";
    $total = mysql_result($this->dbQuery($query), 0);
    return $total;
  }

  function process($current, $total) {
    $node_type = variable_get('dadaimc2drupal_node_type_media', '');
    $query = "SELECT objectid, created_datetime, modified_timestamp, feature, displayable, related_url1 FROM media WHERE parent_class='' LIMIT $current, ".$this->step;
    $rsc = $this->dbQuery($query);
    while ($row = mysql_fetch_object($rsc)) {
      $row->node_type = $node_type;
      if ($row->caption) {
        if (strlen($row->caption) > 0) {
          $row->heading = $row->caption;
        }
        else if (strlen($row->caption) > 64) {
          $row->heading = substr($row->caption, 0, 64) .'...';
        }
        $row->heading = $row->orig_filename .': '. $row->heading;
      }
      else {
        $row->heading = $row->orig_filename;
      }
      $row->type = 'Media';
      $row->feature = 0;
      $row->summary = '';
      $row->body = '';
      $row->section = '';
      $row->embedded_media = '';
      $row->authorid = '';
      $row->author = ($row->contributor!='')?$row->contributor:$row->artist;
      $row->related_url2 = '';

      $node = $this->saveNode($row);
      if (is_object($node)&&($node->nid)) {
        $record = array('objectid' => $row->objectid, 'nid' => $node->nid);
        drupal_write_record('dada_media', $record);        
      }
      $this->updateContext();
    }
  }
}
