<?php

/**
 * Implementation of hook_command().
 */
function dadaimc2drupal_drush_command() {
  $items = array();
  $items['dadaimc2drupal-sql-cli'] = array(
    'description' => 'Connects to mysql cli with dadaimc credentials.',
    'callback' => 'drush_dadaimc2drupal_sql_cli_callback',
    'aliases' => array('dadaimc-sql-cli', 'dada-sql-cli')
  );
  return $items;
}

/**
 * Command callback.
 */
function drush_dadaimc2drupal_sql_cli_callback() {
  $db_url = 'mysqli://';
  $db_url .= variable_get('dadaimc2drupal_dbuser', NULL);
  $db_url .= ':';
  $db_url .= variable_get('dadaimc2drupal_dbpass', NULL);
  $db_url .= '@';
  $db_url .= variable_get('dadaimc2drupal_dbhost', NULL);
  $db_url .= '/';
  $db_url .= variable_get('dadaimc2drupal_dbname', NULL);
  $GLOBALS['db_url'] = $db_url;
  drush_sql_cli();
}
