<?php

require_once 'base.batch.inc';

/**
 * Batch operation. Import dadaIMC articles as nodes.
 *
 * Fields not imported:
 * | modified_by | deleted | language | author | media | submitted | displayable | rating | local_interest | thumbnail | license | comment_notification | revision
 */
class dadaImportArticles extends BaseBatchOperation implements iBatchOperation {
  public $token = 'articles';

  function getTotal() {
    # to only import features.
    #$query = "select count(a.objectid) from articles a left join features f on f.refid=a.objectid WHERE f.ref_class='Article'";
    $query = 'SELECT COUNT(objectid) FROM articles';
    $total = mysql_result($this->dbQuery($query), 0);
    return $total;
  }

  function process($current, $total) {
   $node_type = variable_get('dadaimc2drupal_node_type_articles', '');
    # to only import features
    #$query = "SELECT a.objectid, a.created_datetime, a.edit_datetime, a.heading, a.displayable, a.modified_timestamp, a.feature, a.authorid, a.summary, a.body, a.section, a.related_url1, a.related_url2, a.embedded_media, a.mime_type FROM articles a left join features f on f.refid=a.objectid WHERE f.ref_class='Article' ORDER BY objectid ASC LIMIT $current, ".$this->step;
    $query = "SELECT objectid, created_datetime, edit_datetime, heading, displayable, modified_timestamp, feature, authorid, summary, body, section, related_url1, related_url2, embedded_media, mime_type FROM articles ORDER BY objectid ASC LIMIT $current, ".$this->step;
    $rsc = $this->dbQuery($query);
    while ($row = mysql_fetch_object($rsc)) {
      $row->type = "Article";
      $row->node_type = $node_type;
      $node = $this->saveNode($row);
      if (is_object($node)) {
        $record = array('objectid' => $row->objectid, 'nid' => $node->nid);
        drupal_write_record('dada_articles', $record);
      }
      $this->updateContext();
    }
  }
}
